#include "keys.h"



void sh_key::keyPressEvent ( QKeyEvent * event ){
    this->setText(QString("%1").arg(event->nativeScanCode()));
    event->ignore();
}

sh_key::sh_key(QWidget *parent) :
        QLineEdit(parent)
{
    this->setAlignment(Qt::AlignCenter);
    this->setInputMethodHints(Qt::ImhNoPredictiveText);
}



keys::keys(QWidget *parent) :
        QWidget(parent)
{

    ks=QStringList()<<tr("Left")<<tr("Right")<<tr("Up")
                                <<tr("Down")<<tr("o")<<tr("x")<<tr("triangle")
                                <<tr("square")<<tr("Select")<<tr("Start")
                                <<tr("L1")<<tr("R1")<<tr("L2")<<tr("R2")<<tr("Quit")
                                <<tr("Up+Left")<<tr("Up+Right")
                                <<tr("Down+Left")<<tr("Down+Right")
                                <<tr("Save")<<tr("Load")<<tr("slot+")<<tr("slot-")<<tr("Change disc");

    this->setWindowTitle(tr("Configure keys"));
    this->setWindowFlags(this->windowFlags() | Qt::Window);
    this->setContentsMargins(0,0,0,0);
#ifdef Q_WS_MAEMO_5
    this->setAttribute(Qt::WA_Maemo5StackedWindow);
#endif
    QScrollArea *area=new QScrollArea(this);
    area->setContentsMargins(0,0,0,0);
    QVBoxLayout *lay=new QVBoxLayout(this);
    lay->setSizeConstraint(QLayout::SetMinAndMaxSize);
    lay->setContentsMargins(0,0,0,0);
    lay->addWidget(area);
    QWidget *wg=new QWidget();
    area->setWidget(wg);
    wg->setMinimumSize(600,1200);
    QGridLayout *grid=new QGridLayout(wg);
    grid->setSizeConstraint(QLayout::SetMinAndMaxSize);
    grid->setContentsMargins(0,0,0,0);
    wg->show();
    area->show();
    grid->setHorizontalSpacing(25);
    grid->setVerticalSpacing(10);

    // load current
    QFile file("/opt/psx4m/keys");
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text)){
        QMessageBox msg;
        msg.setText(tr("Couldn't open previous key config"));
        msg.exec();
    }

    int o=0;
    QTextStream in(&file);
    while ((o<ks.count())) {
        QString line="0";
        if (!in.atEnd())
            line = in.readLine();

        QLabel *lbl=new QLabel(ks.at(o),wg);
        grid->addWidget(lbl,o,1,1,1);

        nkey[o]=new sh_key(wg);
        nkey[o]->setFixedSize(250, 60);
        nkey[o]->setParent(wg);

        grid->addWidget(nkey[o],o,0,1,1);
        grid->setRowMinimumHeight(o,60);
        nkey[o]->show();
        nkey[o]->setText(line.trimmed());
        o++;
    }

}

void keys::hideEvent(QHideEvent *)
{
    if (!this->isVisible()){
        QDialog *dlg=new QDialog(this);
        dlg->setWindowTitle(tr("Confirm"));
        QGridLayout *lay=new QGridLayout(dlg);
        lay->setSizeConstraint(QLayout::SetMinAndMaxSize);
        QLabel *lbl=new QLabel(tr("Do you want to save settings?"),dlg);
        lay->addWidget(lbl,1,0,1,2);
        QPushButton *yes=new QPushButton(tr("Yes"),dlg);
        QPushButton *no=new QPushButton(tr("No"),dlg);
        connect (yes,SIGNAL(clicked()),dlg,SLOT(accept()));
        connect (no,SIGNAL(clicked()),dlg,SLOT(reject()));
        connect (dlg,SIGNAL(accepted()),this,SLOT(save()));
        lay->addWidget(yes,2,0);
        lay->addWidget(no ,2,1);
        dlg->exec();
    }
}

void keys::save()
{
    QString sv="";
    for (int i=0;i<ks.count();i++)
        sv=sv+QString("%1\n").arg(nkey[i]->text());

    QFile file("/opt/psx4m/keys");
    if (!file.open(QIODevice::WriteOnly | QIODevice::Text)){
        QMessageBox msg;
        msg.setText("Somethings goes wrong, check permission to keys file");
        msg.exec();
        return;
    }

    QTextStream out(&file);
    out <<sv;
}

keys::~keys()
{

}
